
package guess;

import java.io.IOException;
import javax.inject.Inject;
import javax.websocket.*;
import javax.websocket.server.ServerEndpoint;

@ServerEndpoint("/guessnotify")
public class GameOverNotifier 
{
    @Inject
    Userguess userguess;
    
    @Inject
    Guess guess;
    
    private Session mySession;
    
    @OnOpen
    public void open(Session session, EndpointConfig conf) 
    { 
        guess.addUser();
        mySession = session;
        userguess.setNotifier(this);
        announce(1, guess.getNumberOfUsers());
    }

    @OnClose
    public void close(Session session, CloseReason reason) 
    { 
        guess.removeUser();
        announce(1, guess.getNumberOfUsers());
    }
    
    public void announce(int num, String msg)
    {
        String fullMsg = Integer.toString(num) + ";" + msg;
        try {            
         for (Session sess : mySession.getOpenSessions()) {
            if (sess.isOpen())
               sess.getBasicRemote().sendText(fullMsg);
         }
      } catch (IOException e) { }
    }


}
