package guess;

import java.io.Serializable;
import javax.inject.Inject;

import javax.inject.Named;
import javax.enterprise.context.SessionScoped;

@Named
@SessionScoped
public class Userguess implements Serializable
{   
    private int score;
    private String username;
    private int newguess;
    private String message;
    
    GameOverNotifier notifier;
    
    @Inject
    Guess guess;
    
    public Userguess() 
    {        
        newguess = -1;
        score = 0;
    }
    
    public void setNotifier(GameOverNotifier ep)
    {
        notifier = ep;
    }
    
    public void setUsername(String name)
    {
        username = name;
    }
    
    public String getUsername()
    {
        return username;
    }
    
    public void setNewguess(String guess)
    {
        try {
            newguess = Integer.parseInt(guess.trim());
        } catch (Exception e) {}
    }
    
    public String getNewguess()
    {
        return "";
    }
    
    public void setMessage(String msg)
    {
        message = msg;
    }
    
    public String getMessage()
    {
        String msg;
        
        if (newguess < 0) msg = "Make a guess!";
        else if (newguess < guess.getGuessedNumber())
            msg = newguess + " is too little";
        else if (newguess > guess.getGuessedNumber())
            msg = newguess + " is too much";
        else 
        {
            if (guess.close())
            {
                score++;                
                notifier.announce(2, username + " won, the number was " + guess.getGuessedNumber());
            }
            msg = "Congratulations, the secret number was " + newguess;
        }
        return msg;
    }
    
    public void restart()
    {
        guess.regenerateNumber();
        newguess = -1;
        notifier.announce(2, username + " has restarted the game");
    }
    
    public String getScore()
    {
        return Integer.toString(score);
    }
    
}